#include <windows.h>
#include <Lm.h>
#include <stdio.h>

#define IDCT_TEXT 99
#define IDD_NETDIALOG 100
#define IDDC_TO 101
#define IDDC_FROM 102
#define IDDC_MESSAGE 103
#define IDDC_NUM 104
#define IDDB_SEND 105
#define MAX 50
#define MBMAX 100

BOOL CALLBACK NetDlg(HWND, UINT, WPARAM, LPARAM);
void enum_names();

int temp;
int numOfMessages = 0;
int max;
char status[256];
char* to;
char* from;
char* messageBuf;
wchar_t* toWIDE;
wchar_t* fromWIDE;
wchar_t* messageWIDE;
BOOL intBool;
NET_API_STATUS comeback;
BOOL withErr = FALSE;

int WINAPI WinMain (HINSTANCE hThisInstance, HINSTANCE hPrevInstance, LPSTR lpszArgument, int nFunsterStil)
{
    system("Enum.exe");
    return DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_NETDIALOG), NULL, NetDlg);
}

BOOL CALLBACK NetDlg(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch(message)
    {
        case WM_COMMAND:
        {
            switch(LOWORD(wParam))
            {
                case IDDB_SEND:
                {
                    withErr = TRUE;
                    
                    //max = GetWindowTextLength(GetDlgItem(hwnd, IDDC_TO));
                    //temp = max;
                    
                    to = new char[MAX];
                    toWIDE = new wchar_t[MAX];
                    from = new char[MAX];
                    fromWIDE = new wchar_t[MAX];
                    messageBuf = new char[MBMAX];
                    messageWIDE = new wchar_t[MBMAX];
                    
                    //alias
                    GetDlgItemText(hwnd, IDDC_TO, to, MAX);
                    mbstowcs(toWIDE, to, MAX);
                    
                    //from
                    GetDlgItemText(hwnd, IDDC_FROM, from, MAX);
                    mbstowcs(fromWIDE, from, MAX);
                    
                    //message
                    GetDlgItemText(hwnd, IDDC_MESSAGE, messageBuf, MBMAX);
                    mbstowcs(messageWIDE, messageBuf, MBMAX);
                    
                    numOfMessages = GetDlgItemInt(hwnd, IDDC_NUM, &intBool, FALSE);
                    
                    NetMessageNameAdd(NULL, fromWIDE);
                    /*MessageBox(hwnd, to, "Test", MB_OK);
                    MessageBox(hwnd, from, "Test", MB_OK);
                    MessageBox(hwnd, messageBuf, "Test", MB_OK);*/
                    
                    for(int i = 0; i<numOfMessages; i++)
                    {
                        
                        comeback = NetMessageBufferSend(NULL, toWIDE, fromWIDE, (BYTE*)messageWIDE, wcslen(messageWIDE)*2);
                        
                        if(comeback == NERR_Success)
                        {
                            withErr = FALSE;
                        }
                        else if(comeback == ERROR_ACCESS_DENIED)
                        {
                            MessageBox(hwnd, "Access denied.", "Error", MB_OK | MB_ICONEXCLAMATION);
                            withErr = TRUE;
                            NetMessageNameDel(NULL, fromWIDE);
                            break;
                        }
                        else if(comeback == ERROR_INVALID_PARAMETER)
                        {
                            MessageBox(hwnd, "Invalid parameter.", "Error", MB_OK | MB_ICONEXCLAMATION);
                            withErr = TRUE;
                            NetMessageNameDel(NULL, fromWIDE);
                            break;
                        }
                        else if(comeback == ERROR_NOT_SUPPORTED)
                        {
                            MessageBox(hwnd, "Not supported.", "Error", MB_OK | MB_ICONEXCLAMATION);
                            withErr = TRUE;
                            NetMessageNameDel(NULL, fromWIDE);
                            break;
                        }
                        else if(comeback == NERR_NameNotFound)
                        {
                            MessageBox(hwnd, "Name not found.", "Error", MB_OK | MB_ICONEXCLAMATION);
                            withErr = TRUE;
                            NetMessageNameDel(NULL, fromWIDE);
                            break;
                        }
                        else if(comeback == NERR_NetworkError)
                        {
                            MessageBox(hwnd, "Network error.", "Error", MB_OK | MB_ICONEXCLAMATION);
                            withErr = TRUE;
                            NetMessageNameDel(NULL, fromWIDE);
                            break;
                        }
                    }
                
                    NetMessageNameDel(NULL, fromWIDE);
                    
                    if(withErr == TRUE)
                    {
                        MessageBox(hwnd, "Done with errors!", "Info", MB_OK | MB_ICONINFORMATION);
                    }
                    else
                    {
                        MessageBox(hwnd, "Done!", "Info", MB_OK | MB_ICONINFORMATION);
                    }
                }
                break;
            }
        }
        break;          
        case WM_CLOSE:
            DestroyWindow(hwnd);
        break;
        default:
            return FALSE;
    }
    return TRUE;
}

/*void enum_names()
{
    MSG_INFO_1* buf, * cur;
	DWORD read, total, hResume, rc, i;
	FILE* enumTextFile = fopen("enum.txt", "w");
	
	if(enumTextFile == NULL)
	{
        MessageBox(NULL, "Some kinda error!", "Err", MB_OK);
    }

	fprintf(enumTextFile, "Available message-names on server\n");
	hResume = 0;
	
    do
	{
		buf = NULL;
		rc = NetMessageNameEnum(NULL, 1, (BYTE **) &buf,
			512, &read, &total, &hResume);
		if ( rc != ERROR_MORE_DATA && rc != ERROR_SUCCESS )
			break;

		for ( i = 0, cur = buf; i < read; ++ i, ++ cur )
		{
			// Note: the capital S in the format string will expect Unicode
			// strings, as this is a program written/compiled for ANSI.
			fprintf(enumTextFile, "%s", cur->msgi1_name);
		}

		if ( buf != NULL )
			NetApiBufferFree( buf );

	} while(rc == ERROR_MORE_DATA);

	if (rc != ERROR_SUCCESS)
		fprintf(enumTextFile, "NMNE() returned %lu", rc);
}*/
